//Author: Bo Yan (boyan@geog.ucsb.edu)
//Date: 1/27/2015
//Project: MAT259 Week 2 Project

void draw() {
  
    background(0); //refresh background
    
    textFont(myFont, 30);
    
    text("Average Checkout Duration of Different Levels of Dewey Classification", width/2, colMargin/2);
    
    textFont(myFont);
    
    
    stroke(255);
    strokeWeight(0.5);
    if (r.getState("000-999")) {
        for (int i=0; i<rowNum; i++) {
            for (int j=0; j<colNum; j++) {
                int fillR = colorbrewerG[colorbrewerSelect(dataMatrix[i][j])][0];
                int fillG = colorbrewerG[colorbrewerSelect(dataMatrix[i][j])][1];
                int fillB = colorbrewerG[colorbrewerSelect(dataMatrix[i][j])][2];
                fill(fillR,fillG,fillB);
                rect(rowMargin-9*5+i*cellWidth+(i/10)*5,colMargin+j*cellHeight,cellWidth,cellHeight);
       
            }
        }
        
        fill(255);
        for (int i=0; i<1000; i+=100) {
            String j;
            if (i==0) {
                j = "000";
            } else {
                j = str(i);
            }
            text(j + " - " + (i+100), rowMargin+5*cellWidth-9*5+i/10*cellWidth+i/100*5, height-0.8*colMargin);
        }
        
        for (int i=0; i<10; i++) {
            text(i, rowMargin*0.6, colMargin+cellHeight/2+i*cellHeight);
        }
    }
    
        
    if (r.getState("000-900")) {
        for (int i=0; i<rowNum10; i++) {
            int fillR = colorbrewerG[colorbrewerSelect(dataMatrix10[i][0])][0];
            int fillG = colorbrewerG[colorbrewerSelect(dataMatrix10[i][0])][1];
            int fillB = colorbrewerG[colorbrewerSelect(dataMatrix10[i][0])][2];
            fill(fillR,fillG,fillB);
            rect(rowMargin-9*5+i*cellWidth*10+i*5,colMargin,cellWidth*10,cellHeight*10);
            fill(255);
            String j;
            j = str(i)+"00";
            text(j, rowMargin+5*cellWidth-9*5+i*10*cellWidth+i*5, height-0.8*colMargin);
        }
    }
    
    if (r.getState("000-990")) {
        for (int i=0; i<rowNum100; i++) {
            int fillR = colorbrewerG[colorbrewerSelect(dataMatrix100[i][0])][0];
            int fillG = colorbrewerG[colorbrewerSelect(dataMatrix100[i][0])][1];
            int fillB = colorbrewerG[colorbrewerSelect(dataMatrix100[i][0])][2];
            fill(fillR,fillG,fillB);
            rect(rowMargin-9*5+i*cellWidth+i/10*5,colMargin,cellWidth,cellHeight*10);
            fill(255); 
        }
        
        for (int i=0; i<1000; i+=100) {
            String j;
            if (i==0) {
                j = "000";
            } else {
                j = str(i);
            }
            text(j + " - " + (i+100), rowMargin+5*cellWidth-9*5+i/10*cellWidth+i/100*5, height-0.8*colMargin);
        }
    }

    textFont(myFont, 7);
    
    for (int i=0; i<8; i++){
        fill(colorbrewerG[i][0],colorbrewerG[i][1],colorbrewerG[i][2]);
        rect(width-rowMargin+3*cellWidth, height-colMargin-5-7*(7-i), 30, 5);
    }
    
    fill(255);
    text(">=113", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*7);
    text("71 - 113", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*6);
    text("59 - 71", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*5);
    text("52 - 59", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*4);
    text("46 - 52", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*3);
    text("40 - 46", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*2);
    text("0 - 40", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*1);
    text("No Data", width-rowMargin+3*cellWidth+50, height-colMargin-4-7*0);
    text("Legend", width-rowMargin+3*cellWidth+13, height-colMargin-3-60);


}
